/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

 :host {
  overflow: hidden;

  --reveal-checkbox-opacity: .8;
  --reveal-checkbox-opacity-hover: .6;
  --reveal-checkbox-opacity-active: 1;
  --success-color: #00c100;
  --edit-delete-button-color: #4a4a4f;
}

/* Only overwrite the deemphasized text color in non-dark mode. */
@media not all and (prefers-color-scheme: dark) {
  :host {
    --in-content-deemphasized-text: #737373;
  }
}

.container {
  overflow: auto;
  padding: 40px;
  box-sizing: border-box;
  height: 100%;
  min-width: 520px;
}

@media (max-width: 830px) {
  .container {
    padding-inline: 20px;
  }
}

.column {
  min-height: 100%;
  max-width: 700px;
  display: flex;
  flex-direction: column;
}

button {
  min-width: 100px;
}

form {
  flex-grow: 1;
}

:host([data-editing]) .edit-button,
:host([data-editing]) .copy-button,
:host([data-editing]) login-footer,
:host([data-is-new-login].no-logins) .cancel-button,
:host([data-is-new-login]) .delete-button,
:host([data-is-new-login]) .origin-saved-value,
:host([data-is-new-login]) .meta-info,
:host([data-is-new-login]) login-footer,
:host([data-is-new-login]) .login-item-title,
:host(:not([data-is-new-login])) .new-login-title,
:host(:not([data-editing])) .form-actions-row {
  display: none;
}

input[type="password"],
input[type="text"],
input[type="url"] {
  text-align: match-parent !important; /* override `all: unset` in the rule below */
}

input[type="password"][readOnly],
input[type="text"][readOnly],
input[type="url"][readOnly] {
  all: unset;
  font-size: 1.1em;
  display: inline-block;
  width: -moz-available;
  background-color: transparent !important; /* override common.inc.css */
  text-overflow: ellipsis;
  overflow: hidden;
}

/* We can't use `margin-inline-start` here because we force
 * the input to have dir="ltr", so we set the margin manually
 * using the parent element's directionality. */
.detail-cell:dir(ltr) input:not([type="checkbox"]) {
  margin-left: 0;
}

.detail-cell:dir(rtl) input:not([type="checkbox"]) {
  margin-right: 0;
}

.save-changes-button {
  margin-inline-start: 0; /* Align the button on the start side */
}

.header {
  display: flex;
  align-items: center;
  border-bottom: 1px solid var(--in-content-border-color);
  margin-bottom: 40px;
}

.title {
  margin-block: 0;
  flex-grow: 1;
  overflow: hidden;
  text-overflow: ellipsis;
  white-space: nowrap;
}

.delete-button,
.edit-button {
  color: var(--edit-delete-button-color) !important;
  background-repeat: no-repeat;
  background-position: 8px;
  -moz-context-properties: fill;
  fill: currentColor;
  min-width: auto;
}

.delete-button:dir(rtl),
.edit-button:dir(rtl) {
  background-position-x: right 8px;
}

.delete-button {
  background-image: url("chrome://global/skin/icons/delete.svg");
  padding-inline-start: 30px; /* 8px on each side, and 14px for icon width */
}

.edit-button {
  background-image: url("chrome://browser/skin/edit.svg");
  padding-inline-start: 32px; /* 8px on each side, and 16px for icon width */
}

input[type="url"][readOnly] {
  color: var(--in-content-link-color) !important;
  cursor: pointer;
}

input[type="url"][readOnly]:hover {
  color: var(--in-content-link-color-hover) !important;
  text-decoration: underline;
}

input[type="url"][readOnly]:hover:active {
  color: var(--in-content-link-color-active) !important;
}

.reveal-password-wrapper {
  display: flex;
  align-items: center;
}

.detail-row {
  display: flex;
}

.detail-row-contents {
  display: flex;
  align-items: end;
  flex-basis: 340px; /* Allows for 360px of flex on the end (700px (the default 100% width) - 340px) */
  max-width: 100%;
}

.detail-row,
.form-actions-row {
  margin-bottom: 40px;
}

.detail-cell {
  flex-grow: 1;
  min-width: 0; /* Allow long passwords to collapse down to flex item width */
}

.field-label {
  display: block;
  font-size: smaller;
  color: var(--in-content-deemphasized-text);
  margin-bottom: 8px;
}

:host([data-editing]) .detail-cell input:not([readOnly]):not([type="checkbox"]) {
  width: 280px;
}

.copy-button {
  margin-bottom: 0; /* Align button at the bottom of the row */
  margin-inline-start: 20px;
}

.copy-button:not([data-copied]) .copied-button-text,
.copy-button[data-copied] .copy-button-text {
  display: none;
}

.copy-button[data-copied] {
  color: var(--success-color) !important; /* override common.css */
  background-color: transparent;
  opacity: 1; /* override common.css fading out disabled buttons */
}

.copy-button[data-copied]:-moz-focusring {
  outline-width: 0;
  box-shadow: none;
}

.copied-button-text {
  background-image: url(chrome://global/skin/icons/check.svg);
  background-repeat: no-repeat;
  -moz-context-properties: fill;
  fill: currentColor;
  padding-inline-start: 22px;
}

.copied-button-text:dir(rtl) {
  background-position-x: right;
}

.meta-info {
  font-size: smaller;
  font-weight: 300;
  color: var(--in-content-deemphasized-text);
  margin-block: 0 8px;
}

.meta-info:first-of-type::before {
  content: "";
  display: block;
  margin-bottom: 20px;
  border-top: 1px solid var(--in-content-border-color);
  width: 40px;
}

input.password-display,
input[name="password"] {
  font-family: monospace !important; /* override `all: unset` in the rule above */
}

.reveal-password-checkbox {
  /* !important is needed to override common.css styling for checkboxes */
  background-color: transparent !important;
  border-width: 0 !important;
  background-image: url("chrome://browser/content/aboutlogins/icons/show-password.svg") !important;
  margin-inline: 10px 0 !important;
  cursor: pointer;
  -moz-context-properties: fill;
  fill: currentColor !important;
  opacity: var(--reveal-checkbox-opacity);
  flex-shrink: 0;
}

.reveal-password-checkbox:hover {
  opacity: var(--reveal-checkbox-opacity-hover);
}

.reveal-password-checkbox:hover:active {
  opacity: var(--reveal-checkbox-opacity-active);
}

.reveal-password-checkbox:checked {
  background-image: url("chrome://browser/content/aboutlogins/icons/hide-password.svg") !important;
}

.reveal-password-checkbox:-moz-focusring {
  outline: 2px solid var(--in-content-border-active);
  /* offset outline to align with 1px border-width set for buttons/menulists above. */
  outline-offset: -1px;
  /* Make outline-radius slightly bigger than the border-radius set above,
   * to make the thicker outline corners look smooth */
  -moz-outline-radius: 3px;
  box-shadow: 0 0 0 4px var(--in-content-border-active-shadow);
}

.login-item-favicon {
  width: 24px;
}

.login-item-favicon-wrapper {
  margin-inline-end: 12px;
  height: 24px;
  width: 24px;
  flex-shrink: 0;
  background-image: url("chrome://mozapps/skin/places/defaultFavicon.svg");
  background-repeat: no-repeat;
  background-size: contain;
  -moz-context-properties: fill, fill-opacity;
  fill: currentColor;
  fill-opacity: 0.75;
}

.login-item-favicon-wrapper.hide-default-favicon {
  background-image: none;
}

.vulnerable-alert,
.breach-alert {
  border-radius: var(--panel-border-radius);
  border: 1px solid var(--in-content-border-color);
  box-shadow: 0 2px 8px 0 var(--grey-90-a10);
  font-size: .9em;
  font-weight: 300;
  line-height: 1.4;
  padding-block: 12px;
  padding-inline: 64px 32px;
  margin-block-end: 40px;
  position: relative;
}

.breach-alert {
  background-color: var(--red-70);
  color: #fff;
}

.vulnerable-alert {
  background-color: var(--in-content-box-background);
  color: var(--in-content-text-color);
}

.alert-title {
  font-size: 22px;
  font-weight: normal;
  line-height: 1em;
  margin-block: 0 12px;
}

.alert-date {
  display: block;
  font-weight: 600;
}

.alert-link:visited,
.alert-link {
  font-weight: 600;
}

.breach-alert > .alert-link:visited,
.breach-alert > .alert-link {
  color: inherit;
  text-decoration: underline;
}

.alert-icon {
  position: absolute;
  inset-block-start: 16px;
  inset-inline-start: 32px;
  -moz-context-properties: fill;
  fill: currentColor;
  width: 24px;
}

.alert-learn-more-link:hover,
.alert-learn-more-link:visited,
.alert-learn-more-link {
  position: absolute;
  inset-block-start: 16px;
  inset-inline-end: 32px;
  color: inherit;
  font-size: 13px;
}

.vulnerable-alert > .alert-learn-more-link {
  color: var(--in-content-deemphasized-text);
}

.error-message {
  color: #fff;
  background-color: var(--red-60);
  border: 1px solid transparent;
  padding-block: 6px;
  display: inline-block;
  padding-inline: 32px 16px;
  background-image: url("chrome://global/skin/icons/warning.svg");
  background-repeat: no-repeat;
  background-position: left 10px center;
  -moz-context-properties: fill;
  fill: currentColor;
  margin-bottom: 38px;
}

.error-message:dir(rtl) {
  background-position-x: right 10px;
}

.error-message-link > a,
.error-message-link > a:hover,
.error-message-link > a:hover:active {
  color: currentColor;
  text-decoration: underline;
  font-weight: 600;
}

@media (-moz-windows-default-theme: 0) {
  .alert-icon {
    fill: currentColor;
  }
}

@media (prefers-color-scheme: dark) {
  :host {
    --reveal-checkbox-opacity: .8;
    --reveal-checkbox-opacity-hover: 1;
    --reveal-checkbox-opacity-active: .6;
    --success-color: #86DE74;
    --edit-delete-button-color: #cfcfd1;
  }
}
